"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.InputLabel = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _injectE2E = _interopRequireDefault(require("../../Tools/injectE2E"));

var _interpolation = require("../../Tools/interpolation");

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

var _Radio = _interopRequireDefault(require("./Radio"));

//  strict
var Container =
/*#__PURE__*/
_styledComponents.default.div.withConfig({
  componentId: "sc-1c3roxu-0"
})(["\n  display: flex;\n  flex-direction: column;\n  width: ", ";\n"], (0, _interpolation.prop)('width'));

var InputWrapper =
/*#__PURE__*/
_styledComponents.default.input.attrs({
  'data-e2e': _injectE2E.default,
  name: function name(props) {
    return props.name;
  },
  type: function type(props) {
    return props.type;
  }
}).withConfig({
  componentId: "sc-1c3roxu-1"
})(["\n  display: block;\n  height: 2.7rem;\n  width: ", ";\n  padding: 0 1rem;\n  box-sizing: border-box;\n  font-family: ", ";\n  font-size: ", ";\n  color: ", ";\n  border-width: 1px;\n  border-color: ", ";\n  border-style: solid;\n  border-radius: ", ";\n  background-color: ", ";\n  background-image: none;\n  outline-width: 0;\n  user-select: text;\n  transition: box-shadow 0.25s ease-out;\n\n  &:disabled {\n    color: ", ";\n    border-color: ", ";\n    background: ", ";\n    cursor: not-allowed;\n  }\n\n  &:active:not(:disabled),\n  &:focus:not(:disabled) {\n    box-shadow: 0 0 0 1px\n      ", ";\n  }\n\n  &::placeholder {\n    color: ", ";\n    font-size: ", ";\n  }\n"], (0, _interpolation.prop)('width'), (0, _interpolation.theme)('fontPrimary'), (0, _interpolation.fontSize)('md'), (0, _interpolation.theme)('inputColor'), function (props) {
  return props.error != null ? (0, _interpolation.theme)('dangerColor')(props) : (0, _interpolation.theme)('inputBorderColor')(props);
}, (0, _interpolation.theme)('inputBorderRadius'), (0, _interpolation.theme)('inputBackgroundColor'), (0, _interpolation.theme)('inputColor'), (0, _interpolation.theme)('inputBorderColor'), (0, _interpolation.theme)('inputBackgroundColorDisabled'), function (props) {
  return props.error != null ? 'transparent' : (0, _interpolation.theme)('inputActiveColor');
}, (0, _interpolation.theme)('inputPlaceholderColor'), (0, _interpolation.fontSize)('sm'));

var InputLabel =
/*#__PURE__*/
_styledComponents.default.label.attrs({
  htmlFor: function htmlFor(props) {
    return props.name;
  }
}).withConfig({
  componentId: "sc-1c3roxu-2"
})(["\n  font-family: ", ";\n  font-size: ", ";\n  padding-bottom: 0.5rem;\n  color: ", ";\n  ", ";\n"], (0, _interpolation.theme)('fontPrimary'), (0, _interpolation.fontSize)('sm'), function (props) {
  return props.error && props.disabled !== true ? props.theme.dangerColor : props.theme.inputLabelColor;
}, function (props) {
  return props.disabled === true ? 'cursor: not-allowed' : '';
});

exports.InputLabel = InputLabel;

var Input = function Input(_ref) {
  var className = _ref.className,
      input = _ref.input,
      type = _ref.type,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["className", "input", "type"]);
  var hasLabel = rest.label != null;
  var hasError = rest.error != null;

  if (type === 'checkbox') {
    return _react.default.createElement(_Checkbox.default, (0, _extends2.default)({}, input, rest, {
      type: type
    }));
  }

  if (type === 'radio') {
    return _react.default.createElement(_Radio.default, (0, _extends2.default)({}, input, rest, {
      type: type
    }));
  }

  if (hasLabel || hasError) {
    return _react.default.createElement(Container, {
      className: className,
      width: rest.width
    }, _react.default.createElement(InputLabel, {
      disabled: rest.disabled,
      error: hasError,
      name: rest.name
    }, "".concat(rest.label || '').concat(hasLabel && hasError ? ' - ' : '').concat(rest.error || '')), _react.default.createElement(InputWrapper, (0, _extends2.default)({}, input, rest, {
      type: type
    })));
  }

  return _react.default.createElement(Container, {
    className: className,
    width: rest.width
  }, _react.default.createElement(InputWrapper, (0, _extends2.default)({}, input, rest, {
    type: type
  })));
};

Input.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  e2e: _propTypes.default.string,
  error: _propTypes.default.string,
  input: _propTypes.default.object,
  label: _propTypes.default.string,
  name: _propTypes.default.string,
  type: _propTypes.default.oneOf(['checkbox', 'date', 'number', 'password', 'radio', 'search', 'text']),
  value: _propTypes.default.string,
  width: _propTypes.default.string
} : {};
Input.defaultProps = {
  disabled: false,
  e2e: 'defaultInput',
  type: 'text',
  width: '100%'
};
var _default = Input;
exports.default = _default;